<html>
<head>
<title>Ogre::StringUtil Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1StringUtil.html">StringUtil</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::StringUtil Class Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::StringUtil" -->
<p>Utility class for manipulating Strings.  
 <a href="classOgre_1_1StringUtil.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreString_8h_source.html">OgreString.h</a>&gt;</code></p>

<p><a href="classOgre_1_1StringUtil-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="namespaceOgre.html#a9f14407f349c1ec70ddab871a7806590">StringStream</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StrStreamType</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#ae36e8b6e19fef623f59d56772ed1dd7e">trim</a> (<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;str, bool left=true, bool right=true)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes any whitespace characters, be it standard space or TABs and so on.  <a href="#ae36e8b6e19fef623f59d56772ed1dd7e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a955202dfe4cd4be53cb582065b8ebe9f">split</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;str, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;delims=&quot;\t\n &quot;, unsigned int maxSplits=0, bool preserveDelims=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a StringVector that contains all the substrings delimited by the characters in the passed <code>delims</code> argument.  <a href="#a955202dfe4cd4be53cb582065b8ebe9f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a85e31c955ac26bd91ca02ca365261cfd">tokenise</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;str, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;delims=&quot;\t\n &quot;, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;doubleDelims=&quot;\&quot;&quot;, unsigned int maxSplits=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a StringVector that contains all the substrings delimited by the characters in the passed <code>delims</code> argument, or in the <code>doubleDelims</code> argument, which is used to include (normal) delimeters in the tokenised string.  <a href="#a85e31c955ac26bd91ca02ca365261cfd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a9ffdb5be3d3ac225a551d8c6f961ded2">toLowerCase</a> (<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;str)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Lower-cases all the characters in the string.  <a href="#a9ffdb5be3d3ac225a551d8c6f961ded2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a6a4aa0d892879d1f835398bcc4a8b8d2">toUpperCase</a> (<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;str)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Upper-cases all the characters in the string.  <a href="#a6a4aa0d892879d1f835398bcc4a8b8d2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#aa08af119e6752852489de475559252a0">startsWith</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;str, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;pattern, bool lowerCase=true)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the string begins with the pattern passed in.  <a href="#aa08af119e6752852489de475559252a0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a437e513c495d222d3aca1477cddfb6bf">endsWith</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;str, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;pattern, bool lowerCase=true)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the string ends with the pattern passed in.  <a href="#a437e513c495d222d3aca1477cddfb6bf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#ab936109efdb3b4f224cdddbb37704cd0">standardisePath</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;init)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Method for standardising paths - use forward slashes only, end with slash.  <a href="#ab936109efdb3b4f224cdddbb37704cd0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a861641bda60da5b659c03a21ed5182ba">normalizeFilePath</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;init, bool makeLowerCase=true)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a normalized version of a file path This method can be used to make file path strings which point to the same directory but have different texts to be normalized to the same text.  <a href="#a861641bda60da5b659c03a21ed5182ba"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a16e5c81bee0dee5b89cb9c28f5cc137c">splitFilename</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;qualifiedName, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;outBasename, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;outPath)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Method for splitting a fully qualified filename into the base name and path.  <a href="#a16e5c81bee0dee5b89cb9c28f5cc137c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a3fe567e3f6a50feac64b50805d7e0446">splitFullFilename</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;qualifiedName, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;outBasename, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;outExtention, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;outPath)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Method for splitting a fully qualified filename into the base name, extension and path.  <a href="#a3fe567e3f6a50feac64b50805d7e0446"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a5061ec62dec2f01d8fd94d8d3a3677d6">splitBaseFilename</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;fullName, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;outBasename, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;outExtention)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Method for splitting a filename into the base name and extension.  <a href="#a5061ec62dec2f01d8fd94d8d3a3677d6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a3005f863e31d14ad8e6502eb4d854709">match</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;str, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;pattern, bool caseSensitive=true)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Simple pattern-matching routine allowing a wildcard pattern.  <a href="#a3005f863e31d14ad8e6502eb4d854709"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#a1fbf53b8f6abbc2ee21af4f1b464a25f">replaceAll</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;source, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;replaceWhat, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;replaceWithWhat)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">replace all instances of a sub-string with a another sub-string.  <a href="#a1fbf53b8f6abbc2ee21af4f1b464a25f"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da">BLANK</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant blank string, useful for returning by ref where local does not exist.  <a href="#ad2ead745c8c6f4f7056270e22f29e4da"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Utility class for manipulating Strings. </p>

<p>Definition at line <a class="el" href="OgreString_8h_source.html#l00074">74</a> of file <a class="el" href="OgreString_8h_source.html">OgreString.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a665d79932d54b48b83acff563de7a9e5"></a><!-- doxytag: member="Ogre::StringUtil::StrStreamType" ref="a665d79932d54b48b83acff563de7a9e5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="namespaceOgre.html#a9f14407f349c1ec70ddab871a7806590">StringStream</a> <a class="el" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">Ogre::StringUtil::StrStreamType</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreString_8h_source.html#l00077">77</a> of file <a class="el" href="OgreString_8h_source.html">OgreString.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a437e513c495d222d3aca1477cddfb6bf"></a><!-- doxytag: member="Ogre::StringUtil::endsWith" ref="a437e513c495d222d3aca1477cddfb6bf" args="(const String &amp;str, const String &amp;pattern, bool lowerCase=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool <a class="el" href="classOgre_1_1StringUtil.html#a437e513c495d222d3aca1477cddfb6bf">Ogre::StringUtil::endsWith</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>pattern</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>lowerCase</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns whether the string ends with the pattern passed in. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">pattern</td><td>The pattern to compare with. </td></tr>
    <tr><td class="paramname">lowerCase</td><td>If true, the end of the string will be lower cased before comparison, pattern should also be in lower case. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3005f863e31d14ad8e6502eb4d854709"></a><!-- doxytag: member="Ogre::StringUtil::match" ref="a3005f863e31d14ad8e6502eb4d854709" args="(const String &amp;str, const String &amp;pattern, bool caseSensitive=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool <a class="el" href="classOgre_1_1StringUtil.html#a3005f863e31d14ad8e6502eb4d854709">Ogre::StringUtil::match</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>pattern</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>caseSensitive</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Simple pattern-matching routine allowing a wildcard pattern. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">str</td><td>String to test </td></tr>
    <tr><td class="paramname">pattern</td><td>Pattern to match against; can include simple '*' wildcards </td></tr>
    <tr><td class="paramname">caseSensitive</td><td>Whether the match is case sensitive or not </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a861641bda60da5b659c03a21ed5182ba"></a><!-- doxytag: member="Ogre::StringUtil::normalizeFilePath" ref="a861641bda60da5b659c03a21ed5182ba" args="(const String &amp;init, bool makeLowerCase=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1StringUtil.html#a861641bda60da5b659c03a21ed5182ba">Ogre::StringUtil::normalizeFilePath</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>init</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>makeLowerCase</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a normalized version of a file path This method can be used to make file path strings which point to the same directory but have different texts to be normalized to the same text. </p>
<p>The function:</p>
<ul>
<li>Transforms all backward slashes to forward slashes.</li>
<li>Removes repeating slashes.</li>
<li>Removes initial slashes from the beginning of the path.</li>
<li>Removes ".\" and "..\" meta directories.</li>
<li>Sets all characters to lowercase (if requested) <dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">init</td><td>The file path to normalize. </td></tr>
    <tr><td class="paramname">makeLowerCase</td><td>If true, transforms all characters in the string to lowercase. </td></tr>
  </table>
  </dd>
</dl>
</li>
</ul>

</div>
</div>
<a class="anchor" id="a1fbf53b8f6abbc2ee21af4f1b464a25f"></a><!-- doxytag: member="Ogre::StringUtil::replaceAll" ref="a1fbf53b8f6abbc2ee21af4f1b464a25f" args="(const String &amp;source, const String &amp;replaceWhat, const String &amp;replaceWithWhat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1StringUtil.html#a1fbf53b8f6abbc2ee21af4f1b464a25f">Ogre::StringUtil::replaceAll</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>replaceWhat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>replaceWithWhat</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>replace all instances of a sub-string with a another sub-string. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">source</td><td>Source string </td></tr>
    <tr><td class="paramname">replaceWhat</td><td>Sub-string to find and replace </td></tr>
    <tr><td class="paramname">replaceWithWhat</td><td>Sub-string to replace with (the new sub-string) </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>An updated string with the sub-string replaced </dd></dl>

</div>
</div>
<a class="anchor" id="a955202dfe4cd4be53cb582065b8ebe9f"></a><!-- doxytag: member="Ogre::StringUtil::split" ref="a955202dfe4cd4be53cb582065b8ebe9f" args="(const String &amp;str, const String &amp;delims=&quot;\t\n &quot;, unsigned int maxSplits=0, bool preserveDelims=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&gt;::type <a class="el" href="classOgre_1_1StringUtil.html#a955202dfe4cd4be53cb582065b8ebe9f">Ogre::StringUtil::split</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>delims</em> = <code>&quot;\t\n&#160;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>maxSplits</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>preserveDelims</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a StringVector that contains all the substrings delimited by the characters in the passed <code>delims</code> argument. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">delims</td><td>A list of delimiter characters to split by </td></tr>
    <tr><td class="paramname">maxSplits</td><td>The maximum number of splits to perform (0 for unlimited splits). If this parameters is &gt; 0, the splitting process will stop after this many splits, left to right. </td></tr>
    <tr><td class="paramname">preserveDelims</td><td>Flag to determine if delimiters should be saved as substrings </td></tr>
  </table>
  </dd>
</dl>

<p>Referenced by <a class="el" href="OgreRenderSystemCapabilities_8h_source.html#l00205">Ogre::DriverVersion::fromString()</a>.</p>

</div>
</div>
<a class="anchor" id="a5061ec62dec2f01d8fd94d8d3a3677d6"></a><!-- doxytag: member="Ogre::StringUtil::splitBaseFilename" ref="a5061ec62dec2f01d8fd94d8d3a3677d6" args="(const Ogre::String &amp;fullName, Ogre::String &amp;outBasename, Ogre::String &amp;outExtention)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1StringUtil.html#a5061ec62dec2f01d8fd94d8d3a3677d6">Ogre::StringUtil::splitBaseFilename</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;&#160;</td>
          <td class="paramname"><em>fullName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;&#160;</td>
          <td class="paramname"><em>outBasename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;&#160;</td>
          <td class="paramname"><em>outExtention</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Method for splitting a filename into the base name and extension. </p>

</div>
</div>
<a class="anchor" id="a16e5c81bee0dee5b89cb9c28f5cc137c"></a><!-- doxytag: member="Ogre::StringUtil::splitFilename" ref="a16e5c81bee0dee5b89cb9c28f5cc137c" args="(const String &amp;qualifiedName, String &amp;outBasename, String &amp;outPath)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1StringUtil.html#a16e5c81bee0dee5b89cb9c28f5cc137c">Ogre::StringUtil::splitFilename</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>qualifiedName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>outBasename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>outPath</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Method for splitting a fully qualified filename into the base name and path. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Path is standardised as in standardisePath </dd></dl>

</div>
</div>
<a class="anchor" id="a3fe567e3f6a50feac64b50805d7e0446"></a><!-- doxytag: member="Ogre::StringUtil::splitFullFilename" ref="a3fe567e3f6a50feac64b50805d7e0446" args="(const Ogre::String &amp;qualifiedName, Ogre::String &amp;outBasename, Ogre::String &amp;outExtention, Ogre::String &amp;outPath)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1StringUtil.html#a3fe567e3f6a50feac64b50805d7e0446">Ogre::StringUtil::splitFullFilename</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;&#160;</td>
          <td class="paramname"><em>qualifiedName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;&#160;</td>
          <td class="paramname"><em>outBasename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;&#160;</td>
          <td class="paramname"><em>outExtention</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> &amp;&#160;</td>
          <td class="paramname"><em>outPath</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Method for splitting a fully qualified filename into the base name, extension and path. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Path is standardised as in standardisePath </dd></dl>

</div>
</div>
<a class="anchor" id="ab936109efdb3b4f224cdddbb37704cd0"></a><!-- doxytag: member="Ogre::StringUtil::standardisePath" ref="ab936109efdb3b4f224cdddbb37704cd0" args="(const String &amp;init)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1StringUtil.html#ab936109efdb3b4f224cdddbb37704cd0">Ogre::StringUtil::standardisePath</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>init</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Method for standardising paths - use forward slashes only, end with slash. </p>

</div>
</div>
<a class="anchor" id="aa08af119e6752852489de475559252a0"></a><!-- doxytag: member="Ogre::StringUtil::startsWith" ref="aa08af119e6752852489de475559252a0" args="(const String &amp;str, const String &amp;pattern, bool lowerCase=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static bool <a class="el" href="classOgre_1_1StringUtil.html#aa08af119e6752852489de475559252a0">Ogre::StringUtil::startsWith</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>pattern</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>lowerCase</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns whether the string begins with the pattern passed in. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">pattern</td><td>The pattern to compare with. </td></tr>
    <tr><td class="paramname">lowerCase</td><td>If true, the start of the string will be lower cased before comparison, pattern should also be in lower case. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a85e31c955ac26bd91ca02ca365261cfd"></a><!-- doxytag: member="Ogre::StringUtil::tokenise" ref="a85e31c955ac26bd91ca02ca365261cfd" args="(const String &amp;str, const String &amp;delims=&quot;\t\n &quot;, const String &amp;doubleDelims=&quot;\&quot;&quot;, unsigned int maxSplits=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&gt;::type <a class="el" href="classOgre_1_1StringUtil.html#a85e31c955ac26bd91ca02ca365261cfd">Ogre::StringUtil::tokenise</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>delims</em> = <code>&quot;\t\n&#160;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>doubleDelims</em> = <code>&quot;\&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>maxSplits</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a StringVector that contains all the substrings delimited by the characters in the passed <code>delims</code> argument, or in the <code>doubleDelims</code> argument, which is used to include (normal) delimeters in the tokenised string. </p>
<p>For example, "strings like this". </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">delims</td><td>A list of delimiter characters to split by </td></tr>
    <tr><td class="paramname">delims</td><td>A list of double delimeters characters to tokenise by </td></tr>
    <tr><td class="paramname">maxSplits</td><td>The maximum number of splits to perform (0 for unlimited splits). If this parameters is &gt; 0, the splitting process will stop after this many splits, left to right. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a9ffdb5be3d3ac225a551d8c6f961ded2"></a><!-- doxytag: member="Ogre::StringUtil::toLowerCase" ref="a9ffdb5be3d3ac225a551d8c6f961ded2" args="(String &amp;str)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1StringUtil.html#a9ffdb5be3d3ac225a551d8c6f961ded2">Ogre::StringUtil::toLowerCase</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Lower-cases all the characters in the string. </p>

</div>
</div>
<a class="anchor" id="a6a4aa0d892879d1f835398bcc4a8b8d2"></a><!-- doxytag: member="Ogre::StringUtil::toUpperCase" ref="a6a4aa0d892879d1f835398bcc4a8b8d2" args="(String &amp;str)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1StringUtil.html#a6a4aa0d892879d1f835398bcc4a8b8d2">Ogre::StringUtil::toUpperCase</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Upper-cases all the characters in the string. </p>

</div>
</div>
<a class="anchor" id="ae36e8b6e19fef623f59d56772ed1dd7e"></a><!-- doxytag: member="Ogre::StringUtil::trim" ref="ae36e8b6e19fef623f59d56772ed1dd7e" args="(String &amp;str, bool left=true, bool right=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1StringUtil.html#ae36e8b6e19fef623f59d56772ed1dd7e">Ogre::StringUtil::trim</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>left</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>right</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Removes any whitespace characters, be it standard space or TABs and so on. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The user may specify wether they want to trim only the beginning or the end of the String ( the default action is to trim both). </dd></dl>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="ad2ead745c8c6f4f7056270e22f29e4da"></a><!-- doxytag: member="Ogre::StringUtil::BLANK" ref="ad2ead745c8c6f4f7056270e22f29e4da" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da">Ogre::StringUtil::BLANK</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Constant blank string, useful for returning by ref where local does not exist. </p>

<p>Definition at line <a class="el" href="OgreString_8h_source.html#l00195">195</a> of file <a class="el" href="OgreString_8h_source.html">OgreString.h</a>.</p>

<p>Referenced by <a class="el" href="OgreAnimable_8h_source.html#l00248">Ogre::AnimableObject::getAnimableDictionaryName()</a>, <a class="el" href="OgreCompositorInstance_8h_source.html#l00253">Ogre::CompositorInstance::getScheme()</a>, and <a class="el" href="OgreLog_8h_source.html#l00241">Ogre::Log::Stream::operator&lt;&lt;()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreString_8h_source.html">OgreString.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:08
</p>
</body>
</html>
